// WL_AGENT.C

#include "WL_DEF.H"
#pragma hdrstop

extern  statetype s_rocket ;  // Poet: adding a missile launcher
extern  statetype s_hrocket ;  // Poet: adding a missile launcher
extern  statetype s_fire1 ;  // Poet: adding a missile launcher


/*
=============================================================================

						 LOCAL CONSTANTS

=============================================================================
*/

#define MAXMOUSETURN	10


#define MOVESCALE		150l
#define BACKMOVESCALE	100l
#define ANGLESCALE		20

/*
=============================================================================

						 GLOBAL VARIABLES

=============================================================================
*/



//
// player state info
//
boolean		running;
long		thrustspeed;

unsigned	plux,pluy;			// player coordinates scaled to unsigned

int			anglefrac;
int			gotgatgun;	// JR

int                     gotmlauncher;   // Poet: adding a missile launcher
int                     extraammo;      
int                     gotfthrower;
int                     gotmachinegun;

objtype		*LastAttacker;

/*
=============================================================================

						 LOCAL VARIABLES

=============================================================================
*/


void	T_Player (objtype *ob);
void	T_Attack (objtype *ob);

statetype s_player = {false,0,0,T_Player,NULL,NULL};
statetype s_attack = {false,0,0,T_Attack,NULL,NULL};


long	playerxmove,playerymove;

struct atkinf
{
	char	tics,attack,frame;		// attack is 1 for gun, 2 for knife
} attackinfo[6][14] =                     // Poet: adding a missile launcher

{
{ {6,0,1},{6,2,2},{6,0,3},{6,-1,4} },
{ {6,0,1},{6,1,2},{6,0,3},{6,-1,4} },
{ {6,0,1},{6,1,2},{6,3,3},{6,-1,4} },
{ {6,0,1},{6,1,2},{6,4,3},{6,-1,4} },
{ {6,0,1},{6,1,2},{6,4,3},{6,-1,4} },    // APN: flame thrower             
{ {6,0,1},{6,1,2},{6,0,3},{6,-1,4} },    // Poet: adding a missile launcher
};


int	strafeangle[9] = {0,90,180,270,45,135,225,315,0};

// void DrawWeapon (void);              // Poet: adding a missile launcher
void GiveWeapon (int weapon);
void GiveAmmo (int ammo);
void GiveMissile (int missile);         // Poet: adding a missile launcher
void GiveGascan (int gascan);           // APN: adding a flame thower

//===========================================================================

//----------

void Attack (void);
void Use (void);
void Search (objtype *ob);
void SelectWeapon (void);
void SelectItem (void);

//----------

boolean TryMove (objtype *ob);
void T_Player (objtype *ob);

void ClipMove (objtype *ob, long xmove, long ymove);

/*
=============================================================================

						CONTROL STUFF

=============================================================================
*/

// DHW: BrotherTank routine
// Checks to make sure you have ammo for weapon 
// APN: and that you also have the weapon 
// returns "true" if yes and "false" if no 

int ChkAtkAmmo (int weapon)
{ 
   switch (weapon) 
   {    
      case wp_knife: return 1; 
      case wp_pistol: 
           if (gamestate.ammo > 0) return 1; 
         break; 
      case wp_machinegun: 
           if (gamestate.gotmachinegun && gamestate.ammo > 0) return 1; 
         break; 
      case wp_chaingun: 
           if (gamestate.gotgatgun && gamestate.ammo > 0) return 1; 
         break; 
      case wp_fthrower: 
           if (gamestate.gotfthrower && gamestate.gascan > 0) return 1; 
         break; 
      case wp_mlauncher: 
           if (gamestate.gotmlauncher && gamestate.missile > 0) return 1; 
         break; 
   } 
   return 0; 
} 

/*
======================
=
= CheckWeaponChange
=
= Keys 1-6 change weapons     // Poet: adding a missile launcher
=                             // most of the function is rewritten
======================
*/

void CheckWeaponChange (void)      
{
      int     i,buttons;
      int     j;  

        if (Keyboard[sc_6] && gamestate.gotmlauncher && (gamestate.missile > 0))
            {
            gamestate.chosenweapon = gamestate.weapon = wp_mlauncher ;
            if (!extraammo)
                extraammo = 1;
            DrawAmmo ();
            return ;    
            }

        if (Keyboard[sc_5] && gamestate.gotfthrower && (gamestate.gascan > 0))
            {
            gamestate.chosenweapon = gamestate.weapon = wp_fthrower ;
            if (!extraammo)
                extraammo = 1;
            DrawAmmo ();
            return ;    
            }

        if (Keyboard[sc_1] && gamestate.weapon == wp_knife ||
            Keyboard[sc_2] && gamestate.weapon == wp_pistol||
            Keyboard[sc_3] && gamestate.weapon == wp_machinegun && gamestate.gotmachinegun ||
            Keyboard[sc_4] && gamestate.weapon == wp_chaingun && gamestate.gotgatgun)
            if (extraammo)
                extraammo = 0 ;


        // APN: get best weapon (with ammo) when out of particular ammo


//        if ((gamestate.chosenweapon == wp_mlauncher) && (gamestate.missile<1)) 
        if ((gamestate.weapon == wp_mlauncher) && (gamestate.missile<1)) 
            {
            for (j=gamestate.bestweapon; j>=0; j--)
               if (ChkAtkAmmo(j))
                  {
//                    gamestate.chosenweapon = gamestate.weapon = j;
                    gamestate.weapon = j;
                    break;
                  }
            }
//        else if ((gamestate.chosenweapon == wp_fthrower) && (gamestate.gascan<1))
        else if ((gamestate.weapon == wp_fthrower) && (gamestate.gascan<1))
            {
            for (j=gamestate.bestweapon; j>=0; j--)
               if (ChkAtkAmmo(j))
                  {
//                    gamestate.chosenweapon = gamestate.weapon = j;
                    gamestate.weapon = j;
                    break;
                  }
            }
//        else if ((gamestate.chosenweapon <= wp_chaingun) && (gamestate.chosenweapon
        else if ((gamestate.weapon <= wp_chaingun) && (gamestate.chosenweapon
                  != wp_knife) && (gamestate.ammo < 1))
            {
            for (j=gamestate.bestweapon; j>=0; j--)
               if (ChkAtkAmmo(j))
                  {
//                    gamestate.chosenweapon = gamestate.weapon = j;
//                    gamestate.ammo = 0;    // APN: don't let ammo go negative
                    gamestate.weapon = j;
                    break;
                  }
            }
        else if ((gamestate.weapon == wp_knife) && (gamestate.chosenweapon
                  != wp_knife) && (gamestate.ammo > 0 || gamestate.gascan
                  > 0 || gamestate.missile > 0))
            {
            for (j=gamestate.bestweapon; j>=0; j--)
               if (ChkAtkAmmo(j))
                  {
                    gamestate.chosenweapon = gamestate.weapon = j;
                    break;
                  }
            }
             // must use knife with no ammo
        else if (!gamestate.ammo && !gamestate.gascan && !gamestate.missile)
            gamestate.weapon = wp_knife;  // APN: knife is not "chosen" here
        else if (Keyboard[sc_1] && gamestate.bestweapon >= wp_knife && ChkAtkAmmo(0))
            gamestate.weapon = gamestate.chosenweapon = wp_knife;
        else if (Keyboard[sc_2] && gamestate.bestweapon >= wp_pistol && ChkAtkAmmo(1))
            gamestate.weapon = gamestate.chosenweapon = wp_pistol;
        else if (Keyboard[sc_3] && gamestate.bestweapon >= wp_machinegun && ChkAtkAmmo(2))
            gamestate.weapon = gamestate.chosenweapon = wp_machinegun;
        else if (Keyboard[sc_4] && gamestate.bestweapon >= wp_chaingun && ChkAtkAmmo(3))
            gamestate.weapon = gamestate.chosenweapon = wp_chaingun;
        else if (Keyboard[sc_5] && gamestate.bestweapon >= wp_fthrower && ChkAtkAmmo(4))
            gamestate.weapon = gamestate.chosenweapon = wp_fthrower;
        else if (Keyboard[sc_6] && gamestate.bestweapon >= wp_mlauncher && ChkAtkAmmo(5))
            gamestate.weapon = gamestate.chosenweapon = wp_mlauncher;

        DrawAmmo ();



}

/*
=======================
=
= ControlMovement
=
= Takes controlx,controly, and buttonstate[bt_strafe]
=
= Changes the player's angle and position
=
= There is an angle hack because when going 70 fps, the roundoff becomes
= significant
=
=======================
*/

void ControlMovement (objtype *ob)
{
	long	oldx,oldy;
	int		angle,maxxmove;
	int		angleunits;
	long	speed;

	thrustspeed = 0;

	oldx = player->x;
	oldy = player->y;

//
// side to side move
//
	if (buttonstate[bt_strafe])
	{
	//
	// strafing
	//
	//
		if (controlx > 0)
		{
			angle = ob->angle - ANGLES/4;
			if (angle < 0)
				angle += ANGLES;
			Thrust (angle,controlx*MOVESCALE);	// move to left
		}
		else if (controlx < 0)
		{
			angle = ob->angle + ANGLES/4;
			if (angle >= ANGLES)
				angle -= ANGLES;
			Thrust (angle,-controlx*MOVESCALE);	// move to right
		}
	}
	else
	{
	//
	// not strafing
	//
		anglefrac += controlx;
		angleunits = anglefrac/ANGLESCALE;
		anglefrac -= angleunits*ANGLESCALE;
		ob->angle -= angleunits;

		if (ob->angle >= ANGLES)
			ob->angle -= ANGLES;
		if (ob->angle < 0)
			ob->angle += ANGLES;

	}

//
// forward/backwards move
//
	if (controly < 0)
	{
		Thrust (ob->angle,-controly*MOVESCALE);	// move forwards
	}
	else if (controly > 0)
	{
		angle = ob->angle + ANGLES/2;
		if (angle >= ANGLES)
			angle -= ANGLES;
		Thrust (angle,controly*BACKMOVESCALE);		// move backwards
	}

	if (gamestate.victoryflag)		// watching the BJ actor
		return;

//
// calculate total move
//
	playerxmove = player->x - oldx;
	playerymove = player->y - oldy;
}

/*
=============================================================================

					STATUS WINDOW STUFF

=============================================================================
*/


/*
==================
=
= StatusDrawPic
=
==================
*/

void StatusDrawPic (unsigned x, unsigned y, unsigned picnum)
{
	unsigned	temp;

	temp = bufferofs;
	bufferofs = 0;

	bufferofs = PAGE1START+(200-STATUSLINES)*SCREENWIDTH;
	LatchDrawPic (x,y,picnum);
	bufferofs = PAGE2START+(200-STATUSLINES)*SCREENWIDTH;
	LatchDrawPic (x,y,picnum);
	bufferofs = PAGE3START+(200-STATUSLINES)*SCREENWIDTH;
	LatchDrawPic (x,y,picnum);

	bufferofs = temp;
}


/*
==================
=
= DrawFace
=
==================
*/

void DrawFace (void)
{
	if (gamestate.health)
	{
//                #ifdef SPEAR
		if (godmode)
                        StatusDrawPic (20,4,FACE7APIC+gamestate.faceframe);  // APN: rearrange status bar items
		else
//                #endif
                StatusDrawPic (20,4,FACE1APIC+3*((100-gamestate.health)/25)+gamestate.faceframe);  // APN: rearrange status bar items
                                       // APN: BJ face injured at 25% health
	}
	else
	{
#ifndef SPEAR
	 if (LastAttacker->obclass == needleobj)
           StatusDrawPic (20,4,MUTANTBJPIC);  // APN: rearrange status bar items
	 else
#endif
           StatusDrawPic (20,4,FACE8APIC);  // APN: rearrange status bar items
	}
}


/*
===============
=
= UpdateFace
=
= Calls draw face if time to change
=
===============
*/

#define FACETICS	70

int	facecount;

void	UpdateFace (void)
{

	if (SD_SoundPlaying() == GETGATLINGSND)
	  return;

	facecount += tics;
	if (facecount > US_RndT())
	{
		gamestate.faceframe = (US_RndT()>>6);
		if (gamestate.faceframe==3)
			gamestate.faceframe = 1;
                if (gamestate.faceframe==0)  // APN: BJ does not stare forward
                        gamestate.faceframe = 2;

		facecount = 0;
		DrawFace ();
	}
}



/*
===============
=
= LatchNumber
=
= right justifies and pads with blanks
=
===============
*/

void	LatchNumber (int x, int y, int width, long number)
{
	unsigned	length,c;
	char	str[20];

	ltoa (number,str,10);

	length = strlen (str);

	while (length<width)
	{
		StatusDrawPic (x,y,N_BLANKPIC);
		x++;
		width--;
	}

	c= length <= width ? 0 : length-width;

	while (c<length)
	{
		StatusDrawPic (x,y,str[c]-'0'+ N_0PIC);
		x++;
		c++;
	}
}


/*
===============
=
= DrawHealth
=
===============
*/

void	DrawHealth (void)
{
        LatchNumber (26,16,3,gamestate.health);  // APN: rearrange status bar items  
}


/*
===============
=
= TakeDamage
=
===============
*/

void	TakeDamage (int points,objtype *attacker)
{
	LastAttacker = attacker;

	if (gamestate.victoryflag)
		return;
	if (gamestate.difficulty==gd_baby)
	  points>>=2;

	if (!godmode)
		gamestate.health -= points;

	if (gamestate.health<=0)
	{
		gamestate.health = 0;
		playstate = ex_died;
		killerobj = attacker;
	}

//        StartDamageFlash (points);     // Dome: removing damage flash

	gotgatgun=0;
        gotmlauncher=0;
        gotfthrower=0;
        gotmachinegun=0;

	DrawHealth ();
	DrawFace ();

	//
	// MAKE BJ'S EYES BUG IF MAJOR DAMAGE!
	//
	#ifdef SPEAR
	if (points > 30 && gamestate.health!=0 && !godmode)
	{
                StatusDrawPic (20,4,BJOUCHPIC);  // APN: rearrange status bar items
		facecount = 0;
	}
	#endif

}


/*
===============
=
= HealSelf
=
===============
*/

void	HealSelf (int points)
{
	gamestate.health += points;
	if (gamestate.health>100)
		gamestate.health = 100;

	DrawHealth ();
	gotgatgun = 0;	// JR
        gotmlauncher=0;
        gotfthrower=0;
        gotmachinegun=0;
	DrawFace ();
}


//===========================================================================


/*
===============
=
= DrawLevel
=
===============
*/

void	DrawLevel (void)
{
      if (gamestate.mapon <= 2)                   // APN: fake level and episodes
        {
        LatchNumber (5,16,1,gamestate.mapon+1);   // APN: rearrange status bar items
        LatchNumber (2,16,1,gamestate.episode);   // APN: rearrange status bar items
        }
      else if (gamestate.mapon <= 6)
        {
        LatchNumber (5,16,1,gamestate.mapon-2);   // APN: rearrange status bar items
        LatchNumber (2,16,1,gamestate.episode+1); // APN: rearrange status bar items
        }
      else if (gamestate.mapon <= 11)
        {
        LatchNumber (5,16,1,gamestate.mapon-6);   // APN: rearrange status bar items
        LatchNumber (2,16,1,gamestate.episode+2); // APN: rearrange status bar items
        }
      else if (gamestate.mapon <= 16)
        {
        LatchNumber (5,16,1,gamestate.mapon-11);  // APN: rearrange status bar items
        LatchNumber (2,16,1,gamestate.episode+3); // APN: rearrange status bar items
        }
      else if (gamestate.mapon <= 22)
        {
        LatchNumber (5,16,1,gamestate.mapon-16);  // APN: rearrange status bar items
        LatchNumber (2,16,1,gamestate.episode+4); // APN: rearrange status bar items
        }
      else if (gamestate.mapon <= 29)
        {
        LatchNumber (5,16,1,gamestate.mapon-22);  // APN: rearrange status bar items
        LatchNumber (2,16,1,gamestate.episode+5); // APN: rearrange status bar
        }
}

//===========================================================================


/*
===============
=
= DrawLives
=
===============
*/

void	DrawLives (void)
{
        LatchNumber (23,16,1,gamestate.lives); // APN: rearrange status bar items
}


/*
===============
=
= GiveExtraMan
=
===============
*/

void	GiveExtraMan (void)
{
	if (gamestate.lives<9)
		gamestate.lives++;
	DrawLives ();
	SD_PlaySound (BONUS1UPSND);
}

//===========================================================================

/*
===============
=
= DrawScore
=
===============
*/

void	DrawScore (void)
{
        LatchNumber (7,16,7,gamestate.score);  // APN: rearrange status bar items
}

/*
===============
=
= GivePoints
=
===============
*/

void	GivePoints (long points)
{
	gamestate.score += points;

             //  APN: Bonus life for 50 treasures now, not points

//        while (gamestate.score >= gamestate.nextextra) 
//        {
//                gamestate.nextextra += EXTRAPOINTS;
//                GiveExtraMan ();
//        }
	DrawScore ();
}

//===========================================================================

/*
===============
=
= DrawItems       // APN: count treasures as items rather than score points
=                 // APN: rearrange status bar items
===============
*/

void    DrawItems (void)
{
        LatchNumber (16,16,2,gamestate.items);
}

/*
===============
=
= TallyItems     // APN: count treasures as items rather than score points  
=
===============
*/

void    TallyItems (void)
{
        if (gamestate.items == 50)
        {
                gamestate.items = 0;
                GiveExtraMan ();
        }
        DrawItems ();
}

//===========================================================================

/*
==================
=
= DrawWeapon
=
==================
*/

void DrawWeapon (void)           // APN: rearrange status bar items
{
//        StatusDrawPic (32,8,KNIFEPIC+gamestate.weapon); 
}


/*
==================
=
= DrawKeys
=
==================
*/

void DrawKeys (void)
{
	if (gamestate.keys & 1)
                StatusDrawPic (38,3,GOLDKEYPIC);  // APN: rearrange status bar items
	else
                StatusDrawPic (38,3,NOKEYPIC);    // APN: rearrange status bar items

	if (gamestate.keys & 2)
                StatusDrawPic (38,23,SILVERKEYPIC); // APN: rearrange status bar items
	else
                StatusDrawPic (38,23,NOKEYPIC);     // APN: rearrange status bar items
}



/*
==================
=
= GiveWeapon             // Poet: adding a missile launcher
=                        // most of function is rewritten
==================
*/

void GiveWeapon (int weapon)
{
//        switch (weapon)
//        {
//            case wp_pistol: GiveAmmo (4); break;
//            case wp_machinegun: GiveAmmo (6); gamestate.gotmachinegun = 1; break;
//            case wp_chaingun: GiveAmmo (20); gamestate.gotgatgun = 1; break;  // APN: chaingun gives 20 ammo
//            case wp_fthrower: GiveGascan (20); gamestate.gotfthrower = 1; break;  // APN: flamethrower gives 20 ammo
//            case wp_mlauncher: GiveMissile (5); gamestate.gotmlauncher = 1; break;  // APN: missile launcher gives 5 ammo
//        }

        if (weapon != wp_mlauncher && weapon != wp_fthrower)
        {            
           switch (weapon)
           {
//               case wp_pistol: GiveAmmo (4); break;
               case wp_machinegun: 
                   GiveAmmo (6); 
                   if ((!gamestate.gotmachinegun && !gamestate.gotgatgun &&
                        gamestate.weapon != wp_fthrower && gamestate.weapon
                        != wp_mlauncher) || (!gamestate.gotmachinegun &&
                        gamestate.weapon <= wp_pistol))
                           gamestate.weapon = gamestate.chosenweapon = weapon;

                   gamestate.gotmachinegun = 1;
                   break;

               case wp_chaingun:
                   GiveAmmo (20);             // APN: chaingun gives 20 ammo
                   if (!gamestate.gotgatgun && gamestate.weapon
                       != wp_fthrower && gamestate.weapon != wp_mlauncher)
                        gamestate.weapon = gamestate.chosenweapon = weapon;

                   gamestate.gotgatgun = 1;
                   break;

           }
        }
        else if (weapon == wp_fthrower)
        {
//        if (!gamestate.gotfthrower)
        if (!gamestate.gotfthrower && gamestate.weapon != wp_mlauncher) 
               {
               gamestate.weapon = gamestate.chosenweapon = weapon;
               extraammo = 1;
               gamestate.gotfthrower = 1;
//               gamestate.ammo++;
               }
        GiveGascan (20);        // APN: Flame Thrower gives 20 ammo
//        return;
        }
        else     // weapon == wp_mlauncher
        {
        if (!gamestate.gotmlauncher)
               {
               gamestate.weapon = gamestate.chosenweapon = weapon;
               extraammo = 1;
               gamestate.gotmlauncher = 1;       // APN: Poet had -1 here
//               gamestate.ammo++;
               }
        GiveMissile (5);        // APN: Missile launcher gives 5 ammo
//        return;
        }

 
	if (gamestate.bestweapon<weapon)
		gamestate.bestweapon = gamestate.weapon
		= gamestate.chosenweapon = weapon;

}

//===========================================================================

/*
===============
=
= DrawAmmo
=
===============
*/

void	DrawAmmo (void)
{
        if (gamestate.ammo < 0)  // APN: don't let ammo go negative
            gamestate.ammo = 0;

        if (gamestate.weapon == wp_fthrower)
            LatchNumber (33,16,3,gamestate.gascan);  // APN: rearrange status bar items

        else if (gamestate.weapon == wp_mlauncher)
            LatchNumber (33,16,3,gamestate.missile);  // APN: rearrange status bar items

// APN: replacement code for Third Encounter and up
//        else if (gamestate.weapon != wp_mlauncher && gamestate.weapon != wp_fthrower &&
//                 gamestate.weapon != wp_knife)

        else if (gamestate.weapon != wp_mlauncher && gamestate.weapon != wp_fthrower)
            LatchNumber (33,16,3,gamestate.ammo);  // APN: rearrange status bar items

// APN: add this for Third Encounter and up
//        else if (gamestate.weapon == wp_knife)
//            LatchNumber (33,16,3,0);     // APN: always show 0 ammo for knife                                   


}


/*
===============
=
= GiveGascan     //  APN: adding a flame thrower. This is a new function.
=
===============
*/

void    GiveGascan (int gascan)
{
        gamestate.gascan += gascan;

        if (gamestate.gascan > 99)
            gamestate.gascan = 99;  // APN: 99 is max gascans for Mac

//        DrawGascan();
        DrawAmmo();

}


/*
===============
=
= GiveMissile     //  Poet: adding a missile launcher. This is a new function.
=
===============
*/

void    GiveMissile (int missile)
{
        gamestate.missile += missile;

        if (gamestate.missile > 99)
            gamestate.missile = 99;  // APN: 99 is max rockets for Mac

//        DrawMissile();
        DrawAmmo();

}


/*
===============
=
= GiveAmmo
=
===============
*/

void	GiveAmmo (int ammo)
{
//        if (!gamestate.ammo)                            // knife was out
//        {
//                if (!gamestate.attackframe)
//                {
//                        gamestate.weapon = gamestate.chosenweapon;
//                        DrawWeapon ();
//                }
//        }

        gamestate.ammo += ammo;

        if (gamestate.backpack == 1)              // Joe: adding a backpack
        {                                         // APN: Mac wolf backpack
                 if (gamestate.ammo > 199)        // behavior
                 gamestate.ammo = 199;
        }
        else if (gamestate.backpack == 2)
        {
                 if (gamestate.ammo > 299)
                 gamestate.ammo = 299;
        }
        else
        {
                 if (gamestate.ammo > 99)
                 gamestate.ammo = 99;
        }


	DrawAmmo ();
}

//===========================================================================

/*
==================
=
= GiveKey
=
==================
*/

void GiveKey (int key)
{
	gamestate.keys |= (1<<key);
	DrawKeys ();
}



/*
=============================================================================

							MOVEMENT

=============================================================================
*/


/*
===================
=
= GetBonus
=
===================
*/
void GetBonus (statobj_t *check)
{
	switch (check->itemnumber)
	{
	case	bo_firstaid:
		if (gamestate.health == 100)
			return;

		SD_PlaySound (HEALTH2SND);
		HealSelf (25);
		break;

	case	bo_key1:
	case	bo_key2:
	case	bo_key3:
	case	bo_key4:
		GiveKey (check->itemnumber - bo_key1);
		SD_PlaySound (GETKEYSND);
		break;

	case	bo_cross:
		SD_PlaySound (BONUS1SND);
//                GivePoints (100);        // APN: count treasures as items rather than score points
		gamestate.treasurecount++;
                gamestate.items++;         // APN: count treasures as items rather than score points
                TallyItems();              // APN: count treasures as items rather than score points
		break;
	case	bo_chalice:
		SD_PlaySound (BONUS2SND);
//                GivePoints (500);        // APN: count treasures as items rather than score points
		gamestate.treasurecount++;
                gamestate.items++;         // APN: count treasures as items rather than score points
                TallyItems();              // APN: count treasures as items rather than score points
		break;
	case	bo_bible:
		SD_PlaySound (BONUS3SND);
//                GivePoints (1000);       // APN: count treasures as items rather than score points
		gamestate.treasurecount++;
                gamestate.items++;         // APN: count treasures as items rather than score points
                TallyItems();              // APN: count treasures as items rather than score points
		break;
	case	bo_crown:
		SD_PlaySound (BONUS4SND);
//                GivePoints (5000);       // APN: count treasures as items rather than score points
		gamestate.treasurecount++;
                gamestate.items++;         // APN: count treasures as items rather than score points
                TallyItems();              // APN: count treasures as items rather than score points
		break;

        case    bo_clip:                   // Joe: adding a backpack
                if (gamestate.ammo == 299)
			return;

                if ((gamestate.ammo == 199) && (gamestate.backpack == 1))
			return;

                if ((gamestate.ammo == 99) && (gamestate.backpack == 0))
			return;
                
		SD_PlaySound (GETAMMOSND);
                GiveAmmo (5);             // APN: all clips contain 5 bullets
		break;
        case    bo_clip2:                 // Joe: adding a backpack
                if (gamestate.ammo == 299)
			return;

                if ((gamestate.ammo == 199) && (gamestate.backpack == 1))
			return;

                if ((gamestate.ammo == 99) && (gamestate.backpack == 0))
			return;


		SD_PlaySound (GETAMMOSND);
                GiveAmmo (5);             // APN: all clips contain 5 bullets
		break;

//#ifdef SPEAR                            // Dome: adding the 25 ammo box
        case    bo_25clip:                // Joe: adding a backpack
                if (gamestate.ammo == 299)
			return;

                if ((gamestate.ammo == 199) && (gamestate.backpack == 1))
			return;

                if ((gamestate.ammo == 99) && (gamestate.backpack == 0))
			return;


                SD_PlaySound (BONUS1SND);  // Dome: adding the 25 ammo box
		GiveAmmo (25);
		break;
//#endif                                   // Dome: adding the 25 ammo box

	case	bo_machinegun:
                if ((gamestate.ammo == 299) && (gamestate.gotmachinegun == 1))
			return;

                if ((gamestate.ammo == 199) && (gamestate.backpack == 1) && (gamestate.gotmachinegun == 1))
			return;

                if ((gamestate.ammo == 99) && (gamestate.backpack == 0) && (gamestate.gotmachinegun == 1))
			return;

		SD_PlaySound (GETMACHINESND);
		GiveWeapon (wp_machinegun);
//                gotmachinegun=1;      // APN: gets assigned in GiveWeapon
		break;
	case	bo_chaingun:
		SD_PlaySound (GETGATLINGSND);
		GiveWeapon (wp_chaingun);

                StatusDrawPic (20,4,GOTGATLINGPIC);  // APN: rearrange status bar items
		facecount = 0;
//                gotgatgun = 1;        // APN: gets assigned in GiveWeapon
		break;

	case	bo_fullheal:
		SD_PlaySound (BONUS1UPSND);
		HealSelf (99);
//                GiveAmmo (25);           // APN: don't give ammo with 1-up
		GiveExtraMan ();
		gamestate.treasurecount++;
		break;

	case	bo_food:
		if (gamestate.health == 100)
			return;

		SD_PlaySound (HEALTH1SND);
		HealSelf (10);
		break;

	case	bo_alpo:
		if (gamestate.health == 100)
			return;

		SD_PlaySound (HEALTH1SND);
		HealSelf (4);
		break;

        case    bo_backpack:              // Joe: adding a backpack

                if (gamestate.ammo == 299 && gamestate.gascan == 99 && gamestate.missile == 99)
                        return;

                if (gamestate.backpack < 2)
                        gamestate.backpack++;

                SD_PlaySound (BONUS1SND);
                GiveAmmo (20);
                GiveMissile (5);      // APN: backpack adds 5 rockets
                GiveGascan (2);       // APN: backpack adds 2 gas cans

                break;

        case    bo_spear:                  // Poet: adding a missile launcher
                SD_PlaySound (GETGATLINGSND);
                GiveWeapon (wp_mlauncher);
                StatusDrawPic (20,4,GOTGATLINGPIC);
                facecount = 0;
                gotmlauncher = 1;
                break;

        case    bo_rockets:               // Poet: adding a missile launcher

                if (gamestate.missile == 99)
			return;

                SD_PlaySound (BONUS1SND);
                GiveMissile (5);

                break;

        case    bo_gibs:                 // APN: adding a flame thower
                SD_PlaySound (GETGATLINGSND);
                GiveWeapon (wp_fthrower);
                StatusDrawPic (20,4,GOTGATLINGPIC);
                facecount = 0;
                gotfthrower = 1;
                break;


        case    bo_gascan:               // APN: adding a flame thrower

                if (gamestate.gascan == 99)
			return;

                SD_PlaySound (BONUS1SND);
                GiveGascan (14);

                break;


	}

//        StartBonusFlash ();                 // APN: removing damage flash
	check->shapenum = -1;			// remove from list
}


/*
===================
=
= TryMove
=
= returns true if move ok
= debug: use pointers to optimize
===================
*/

boolean TryMove (objtype *ob)
{
	int			xl,yl,xh,yh,x,y;
	objtype		*check;
	long		deltax,deltay;

	xl = (ob->x-PLAYERSIZE) >>TILESHIFT;
	yl = (ob->y-PLAYERSIZE) >>TILESHIFT;

	xh = (ob->x+PLAYERSIZE) >>TILESHIFT;
	yh = (ob->y+PLAYERSIZE) >>TILESHIFT;

//
// check for solid walls
//
	for (y=yl;y<=yh;y++)
		for (x=xl;x<=xh;x++)
		{
			check = actorat[x][y];
			if (check && check<objlist)
				return false;
		}

//
// check for actors
//
	if (yl>0)
		yl--;
	if (yh<MAPSIZE-1)
		yh++;
	if (xl>0)
		xl--;
	if (xh<MAPSIZE-1)
		xh++;

	for (y=yl;y<=yh;y++)
		for (x=xl;x<=xh;x++)
		{
			check = actorat[x][y];
			if (check > objlist
			&& (check->flags & FL_SHOOTABLE) )
			{
				deltax = ob->x - check->x;
				if (deltax < -MINACTORDIST || deltax > MINACTORDIST)
					continue;
				deltay = ob->y - check->y;
				if (deltay < -MINACTORDIST || deltay > MINACTORDIST)
					continue;

				return false;
			}
		}

	return true;
}


/*
===================
=
= ClipMove
=
===================
*/

void ClipMove (objtype *ob, long xmove, long ymove)
{
	long	basex,basey;

	basex = ob->x;
	basey = ob->y;

	ob->x = basex+xmove;
	ob->y = basey+ymove;
	if (TryMove (ob))
		return;

	if (noclip && ob->x > 2*TILEGLOBAL && ob->y > 2*TILEGLOBAL &&
	ob->x < (((long)(mapwidth-1))<<TILESHIFT)
	&& ob->y < (((long)(mapheight-1))<<TILESHIFT) )
		return;		// walk through walls

//        if (!SD_SoundPlaying())          // MCS: removing the hitwall sound
//                SD_PlaySound (HITWALLSND);

	ob->x = basex+xmove;
	ob->y = basey;
	if (TryMove (ob))
		return;

	ob->x = basex;
	ob->y = basey+ymove;
	if (TryMove (ob))
		return;

	ob->x = basex;
	ob->y = basey;
}

//==========================================================================

/*
===================
=
= VictoryTile
=
===================
*/

void VictoryTile (void)
{
#ifndef SPEAR
	SpawnBJVictory ();
#endif

	gamestate.victoryflag = true;
}


/*
===================
=
= Thrust
=
===================
*/

void Thrust (int angle, long speed)
{
	long xmove,ymove;
	long	slowmax;
	unsigned	offset;


	//
	// ZERO FUNNY COUNTER IF MOVED!
	//
	#ifdef SPEAR
	if (speed)
		funnyticount = 0;
	#endif

	thrustspeed += speed;
//
// moving bounds speed
//
	if (speed >= MINDIST*2)
		speed = MINDIST*2-1;

	xmove = FixedByFrac(speed,costable[angle]);
	ymove = -FixedByFrac(speed,sintable[angle]);

	ClipMove(player,xmove,ymove);

	player->tilex = player->x >> TILESHIFT;		// scale to tile values
	player->tiley = player->y >> TILESHIFT;

	offset = farmapylookup[player->tiley]+player->tilex;
	player->areanumber = *(mapsegs[0] + offset) -AREATILE;

	if (*(mapsegs[1] + offset) == EXITTILE)
		VictoryTile ();
}


/*
=============================================================================

								ACTIONS

=============================================================================
*/


/*
===============
=
= Cmd_Fire
=
===============
*/

void Cmd_Fire (void)
{
	buttonheld[bt_attack] = true;

	gamestate.weaponframe = 0;

	player->state = &s_attack;

	gamestate.attackframe = 0;
	gamestate.attackcount =
		attackinfo[gamestate.weapon][gamestate.attackframe].tics;
	gamestate.weaponframe =
		attackinfo[gamestate.weapon][gamestate.attackframe].frame;
}

//===========================================================================

/*
===============
=
= Cmd_Use
=
===============
*/

void Cmd_Use (void)
{
	objtype 	*check;
	int			checkx,checky,doornum,dir;
	boolean		elevatorok;


//
// find which cardinal direction the player is facing
//
	if (player->angle < ANGLES/8 || player->angle > 7*ANGLES/8)
	{
		checkx = player->tilex + 1;
		checky = player->tiley;
		dir = di_east;
		elevatorok = true;
	}
	else if (player->angle < 3*ANGLES/8)
	{
		checkx = player->tilex;
		checky = player->tiley-1;
		dir = di_north;
		elevatorok = false;
	}
	else if (player->angle < 5*ANGLES/8)
	{
		checkx = player->tilex - 1;
		checky = player->tiley;
		dir = di_west;
		elevatorok = true;
	}
	else
	{
		checkx = player->tilex;
		checky = player->tiley + 1;
		dir = di_south;
		elevatorok = false;
	}

	doornum = tilemap[checkx][checky];
	if (*(mapsegs[1]+farmapylookup[checky]+checkx) == PUSHABLETILE)
	{
	//
	// pushable wall
	//

		PushWall (checkx,checky,dir);
		return;
	}
	if (!buttonheld[bt_use] && doornum == ELEVATORTILE && elevatorok)
	{
	//
	// use elevator
	//
		buttonheld[bt_use] = true;

//                                // APN: only flip switch for victory sprite
//
//                if (gamestate.mapon == 2 && gamestate.episode == 0)
//                {
//                tilemap[checkx][checky]++;             // flip switch
//                }

        	if (*(mapsegs[0]+farmapylookup[player->tiley]+player->tilex) == ALTELEVATORTILE)
			playstate = ex_secretlevel;
		else
			playstate = ex_completed;
		SD_PlaySound (LEVELDONESND);
		SD_WaitSoundDone();
	}
	else if (!buttonheld[bt_use] && doornum & 0x80)
	{
		buttonheld[bt_use] = true;
		OperateDoor (doornum & ~0x80);
	}
//        else                          // MCS: removing the space bar sound
//                SD_PlaySound (DONOTHINGSND);

}

/*
=============================================================================

						   PLAYER CONTROL

=============================================================================
*/



/*
===============
=
= SpawnPlayer
=
===============
*/

void SpawnPlayer (int tilex, int tiley, int dir)
{
	player->obclass = playerobj;
	player->active = true;
	player->tilex = tilex;
	player->tiley = tiley;
	player->areanumber =
		*(mapsegs[0] + farmapylookup[player->tiley]+player->tilex);
	player->x = ((long)tilex<<TILESHIFT)+TILEGLOBAL/2;
	player->y = ((long)tiley<<TILESHIFT)+TILEGLOBAL/2;
	player->state = &s_player;
	player->angle = (1-dir)*90;
	if (player->angle<0)
		player->angle += ANGLES;
	player->flags = FL_NEVERMARK;
	Thrust (0,0);				// set some variables

	InitAreas ();
}


//===========================================================================

/*
===============
=
= FlameThrowerAttack
=
= APN: adding a flame thrower. This is a new function.
=
===============
*/

void FlameThrowerAttack (objtype *ob) 
{ 
    if (gamestate.gascan<1) 
    { 
       SD_PlaySound (DONOTHINGSND);
       return;
    } 
   
    SD_PlaySound (FLAMETHROWERSND); 

    GetNewActor (); 

    new->state = &s_hrocket; 
    new->ticcount = 1; 

    new->x = ob->x ; 
    new->y = ob->y ; 
    new->tilex = new->x >> TILESHIFT; 
    new->tiley = new->y >> TILESHIFT; 
 
    new->obclass = hrocketobj; 
    new->dir = nodir; 
    new->angle = ob->angle; 
    new->speed = 0x4200l; 
//    new->flags = FL_NONMARK | FL_BONUS;  // APN: fix for door held open
    new->flags = 10000110;     // FL_NONMARK | FL_NEVERMARK | FL_BONUS
    new->active = true;

    madenoise = true;

    GiveGascan (-1);
} 



//===========================================================================

/*
===============
=
= MissileAttack
=
= Poet: adding a missile launcher. This is a new function.
=
===============
*/

void MissileAttack (objtype *ob) 
{ 
    if (gamestate.missile<1) 
    { 
       SD_PlaySound (DONOTHINGSND);
       return;
    } 
   
    SD_PlaySound (MISSILEFIRESND); 

    GetNewActor (); 

    new->state = &s_rocket; 
    new->ticcount = 1; 

    new->x = ob->x ; 
    new->y = ob->y ; 
    new->tilex = new->x >> TILESHIFT; 
    new->tiley = new->y >> TILESHIFT; 
 
    new->obclass = rocketobj; 
    new->dir = nodir; 
    new->angle = ob->angle; 
    new->speed = 0x4200l; 
//    new->flags = FL_NONMARK | FL_BONUS;  // APN: fix for door held open
    new->flags = 10000110;     // FL_NONMARK | FL_NEVERMARK | FL_BONUS
    new->active = true;

    madenoise = true;

    GiveMissile (-1);
} 

//===========================================================================

/*
===============
=
= T_KnifeAttack
=
= Update player hands, and try to do damage when the proper frame is reached
=
===============
*/

void	KnifeAttack (objtype *ob)
{
	objtype *check,*closest;
	long	dist;

	SD_PlaySound (ATKKNIFESND);
// actually fire
	dist = 0x7fffffff;
	closest = NULL;
	for (check=ob->next ; check ; check=check->next)
		if ( (check->flags & FL_SHOOTABLE)
		&& (check->flags & FL_VISABLE)
		&& abs (check->viewx-centerx) < shootdelta
		)
		{
			if (check->transx < dist)
			{
				dist = check->transx;
				closest = check;
			}
		}

	if (!closest || dist> 0x18000l)
	{
	// missed

		return;
	}

// hit something
	DamageActor (closest,US_RndT() >> 4);
}



void	GunAttack (objtype *ob)
{
	objtype *check,*closest,*oldclosest;
	int		damage;
	int		dx,dy,dist;
	long	viewdist;

        if (gamestate.weapon == wp_mlauncher)
        { 
           MissileAttack (ob); 
//           GiveAmmo (1);
           return;
        }

        if (gamestate.weapon == wp_fthrower)
        { 
           FlameThrowerAttack (ob); 
//           GiveAmmo (1);
           return;
        }

	switch (gamestate.weapon)
	{
	case wp_pistol:
		SD_PlaySound (ATKPISTOLSND);
		break;
	case wp_machinegun:
		SD_PlaySound (ATKMACHINEGUNSND);
		break;
	case wp_chaingun:
		SD_PlaySound (ATKGATLINGSND);
		break;
	}

        gamestate.ammo--;
	madenoise = true;

//
// find potential targets
//
	viewdist = 0x7fffffffl;
	closest = NULL;

	while (1)
	{
		oldclosest = closest;

		for (check=ob->next ; check ; check=check->next)
			if ( (check->flags & FL_SHOOTABLE)
			&& (check->flags & FL_VISABLE)
			&& abs (check->viewx-centerx) < shootdelta
			)
			{
				if (check->transx < viewdist)
				{
					viewdist = check->transx;
					closest = check;
				}
			}

		if (closest == oldclosest)
			return;						// no more targets, all missed

	//
	// trace a line from player to enemey
	//
		if (CheckLine(closest))
			break;

	}

//
// hit something
//
	dx = abs(closest->tilex - player->tilex);
	dy = abs(closest->tiley - player->tiley);
	dist = dx>dy ? dx:dy;

	if (dist<2)
		damage = US_RndT() / 4;
	else if (dist<4)
		damage = US_RndT() / 6;
	else
	{
		if ( (US_RndT() / 12) < dist)		// missed
			return;
		damage = US_RndT() / 6;
	}

	DamageActor (closest,damage);

}

//===========================================================================

/*
===============
=
= VictorySpin
=
===============
*/

void VictorySpin (void)
{
	long	desty;

	if (player->angle > 270)
	{
		player->angle -= tics * 3;
		if (player->angle < 270)
			player->angle = 270;
	}
	else if (player->angle < 270)
	{
		player->angle += tics * 3;
		if (player->angle > 270)
			player->angle = 270;
	}

	desty = (((long)player->tiley-5)<<TILESHIFT)-0x3000;

	if (player->y > desty)
	{
		player->y -= tics*4096;
		if (player->y < desty)
			player->y = desty;
	}
}


//===========================================================================

/*
===============
=
= T_Attack
=
===============
*/

void	T_Attack (objtype *ob)
{
	struct	atkinf	*cur;

	UpdateFace ();

	if (gamestate.victoryflag)		// watching the BJ actor
	{
		VictorySpin ();
		return;
	}

	if ( buttonstate[bt_use] && !buttonheld[bt_use] )
		buttonstate[bt_use] = false;

	if ( buttonstate[bt_attack] && !buttonheld[bt_attack])
		buttonstate[bt_attack] = false;

	ControlMovement (ob);
	if (gamestate.victoryflag)		// watching the BJ actor
		return;

	plux = player->x >> UNSIGNEDSHIFT;			// scale to fit in unsigned
	pluy = player->y >> UNSIGNEDSHIFT;
	player->tilex = player->x >> TILESHIFT;		// scale to tile values
	player->tiley = player->y >> TILESHIFT;

//
// change frame and fire
//
	gamestate.attackcount -= tics;
	while (gamestate.attackcount <= 0)
	{
		cur = &attackinfo[gamestate.weapon][gamestate.attackframe];
		switch (cur->attack)
		{
		case -1:
			ob->state = &s_player;
                        if (!gamestate.ammo)
                        {
//                                gamestate.weapon = wp_knife;
//                                DrawWeapon ();
                        }
			else
			{
				if (gamestate.weapon != gamestate.chosenweapon)
				{
					gamestate.weapon = gamestate.chosenweapon;
//                                        DrawWeapon ();
				}
			};
			gamestate.attackframe = gamestate.weaponframe = 0;
			return;

		case 4:
                        if ((gamestate.ammo<1 && gamestate.weapon == wp_chaingun)||
                            (gamestate.gascan<1 && gamestate.weapon == wp_fthrower))
//                        {
//                                gamestate.ammo = 0;    // APN: don't let ammo go
//                                gamestate.gascan = 0;  // negative!
                                break;
//                        }
			if (buttonstate[bt_attack])
				gamestate.attackframe -= 2;
		case 1:
//                        if (!gamestate.ammo)
//                        {       // can only happen with chain gun
//                                gamestate.attackframe++;
//                                break;
//                        }
			GunAttack (ob);
//                        gamestate.ammo--;
                        DrawAmmo ();
			break;

		case 2:
			KnifeAttack (ob);
			break;

		case 3:
			if (gamestate.ammo && buttonstate[bt_attack])
				gamestate.attackframe -= 2;
			break;
		}

		gamestate.attackcount += cur->tics;
		gamestate.attackframe++;
		gamestate.weaponframe =
			attackinfo[gamestate.weapon][gamestate.attackframe].frame;
	}

}



//===========================================================================

/*
===============
=
= T_Player
=
===============
*/

void	T_Player (objtype *ob)
{
	if (gamestate.victoryflag)		// watching the BJ actor
	{
		VictorySpin ();
		return;
	}

	UpdateFace ();
	CheckWeaponChange ();

	if ( buttonstate[bt_use] )
		Cmd_Use ();

	if ( buttonstate[bt_attack] && !buttonheld[bt_attack])
		Cmd_Fire ();

	ControlMovement (ob);
	if (gamestate.victoryflag)		// watching the BJ actor
		return;


	plux = player->x >> UNSIGNEDSHIFT;			// scale to fit in unsigned
	pluy = player->y >> UNSIGNEDSHIFT;
	player->tilex = player->x >> TILESHIFT;		// scale to tile values
	player->tiley = player->y >> TILESHIFT;
}


